# -*- coding: utf-8 -*-
"""Host country allowed Controller"""

import transaction

from tg import expose, flash, require, url, request, redirect, validate
from tg.decorators import override_template
from pylons.i18n import ugettext as _, lazy_ugettext as l_
from tgext.admin.tgadminconfig import TGAdminConfig
from tgext.admin.controller import AdminController
from repoze.what import predicates
from sqlalchemy import and_

from mirrormanager.lib.base import BaseController
from mirrormanager.model import DBSession, metadata
from mirrormanager.controllers.error import ErrorController
from mirrormanager import model
from mirrormanager.controllers.secure import SecureController

from mirrormanager import model
from mirrormanager.model import *

from mirrormanager.controllers.forms import *
from mirrormanager.controllers.utils import *
from mirrormanager.controllers.hostlistitem import HostListitemController

host_country_allowed_form = HostCountryAllowedForm(submit_text='Create Country Allowed')

class HostCountryAllowedController(HostListitemController):
    submit_action_prefix="/host_country_allowed"
    page_title = "New Host Country Allowed"
    form = host_country_allowed_form

    def do_get(self, id):
        v = HostCountryAllowed.get(id)
        return dict(values=v, host=v.host)

    def do_create(self, host, kwargs):
        hc = HostCountryAllowed(host=host.id, country=kwargs['country'])
        model.DBSession.add(hc)
    
    @expose(template="mirrormanager.templates.boringhostform")
    def delete(self, id, **kwargs):
        hc = model.DBSession.query(HostCountryAllowed).filter_by(id = id).one()
        host = hc.host
        model.DBSession.delete(hc)
        flash("Allowed country deleted")
        redirect(url("/host/%s" % host))
