# -*- coding: utf-8 -*-
"""Host Net block Controller"""

import transaction

from tg import expose, flash, require, url, request, redirect, validate, config
from tg.decorators import override_template
from pylons.i18n import ugettext as _, lazy_ugettext as l_
from tgext.admin.tgadminconfig import TGAdminConfig
from tgext.admin.controller import AdminController
from repoze.what import predicates
from sqlalchemy import and_

import IPy
IPy.check_addr_prefixlen = 0

from mirrormanager.lib.base import BaseController
from mirrormanager.model import DBSession, metadata
from mirrormanager.controllers.error import ErrorController
from mirrormanager import model
from mirrormanager.controllers.secure import SecureController

from mirrormanager import model
from mirrormanager.model import *

from mirrormanager.controllers.forms import *
from mirrormanager.controllers.utils import *
from mirrormanager.controllers.hostlistitem import HostListitemController

host_netblock_form = HostNetblockForm(submit_text='Create Host Netblock')


class HostNetblockController(HostListitemController):
    submit_action_prefix="/host_netblock"
    page_title = "New Host Netblock"
    form = host_netblock_form

    def do_get(self, id):
        v = model.DBSession.query(HostNetblock).filter_by(id = id).one()
        return dict(values=v, host=v.host)

    def do_create(self, host, kwargs):
        print "host net block -- create"
        print kwargs
        max_ipv4_netblock_size = config.get('mirrormanager.max_ipv4_netblock_size', '/16')
        max_ipv6_netblock_size = config.get('mirrormanager.max_ipv6_netblock_size', '/32')

        emsg = "Error: IPv4 netblocks larger than %s, and IPv6 netblocks larger than %s can only be created by mirrormanager administrators.  Please ask the mirrormanager administrators for assistance." % (max_ipv4_netblock_size, max_ipv6_netblock_size)

        ipv4_block = IPy.IP('10.0.0.0%s' % max_ipv4_netblock_size)
        ipv6_block = IPy.IP('fec0::%s'   % max_ipv6_netblock_size)
        try:
            ip = IPy.IP(kwargs['netblock'])
            if ((ip.version() == 4 and ip.len() > ipv4_block.len()) or \
                    (ip.version() == 6 and ip.len() > ipv6_block.len())) and \
                    not predicates.in_group(admin_group):
                raise InvalidData, emsg
        except ValueError:
            # also accept DNS hostnames
            pass
        
        host = HostNetblock(host=host.id, netblock=kwargs['netblock'])
        model.DBSession.add(host)
    
    @expose(template="mirrormanager.templates.boringhostform")
    def delete(self, id, **kwargs):
        hc = model.DBSession.query(HostNetblock).filter_by(id = id).one()
        host = hc.host
        model.DBSession.delete(hc)
        flash("Net block deleted")
        redirect(url("/host/%s" % host))
