# -*- coding: utf-8 -*-
"""Repository Controller"""

import transaction

from tg import expose, flash, require, url, request, redirect, validate
from tg.decorators import override_template
from pylons.i18n import ugettext as _, lazy_ugettext as l_
from tgext.admin.tgadminconfig import TGAdminConfig
from tgext.admin.controller import AdminController
from repoze.what import predicates
from sqlalchemy import and_

from mirrormanager.lib.base import BaseController
from mirrormanager.model import DBSession, metadata
from mirrormanager.controllers.error import ErrorController
from mirrormanager import model
from mirrormanager.controllers.secure import SecureController

from mirrormanager import model
from mirrormanager.model import *

from mirrormanager.controllers.forms import *
from mirrormanager.controllers.utils import *
from mirrormanager.controllers.simpledbobject import *

repository_form = RepositoryForm(submit_text='Edit Version')


class RepositoryController(SimpleDbObjectController):
    page_title = "Repository"
    form = repository_form
    myClass = Repository
    url_prefix="repository"

    @expose(template="mirrormanager.templates.boringform")
    @validate(form=repository_form)
    #@error_handler(SimpleDbObjectController.new)
    def create(self, **kwargs):
        print "Repository -- create"
        print kwargs
        return SimpleDbObjectController.create(self, **kwargs)
    

    @expose(template="mirrormanager.templates.boringform")
    @validate(form=repository_form)
    #@error_handler(SimpleDbObjectController.new)
    def update(self, obj, **kwargs):
        print "Repository -- update"
        print obj, kwargs
        model.DBSession.query(Repository).update(kwargs)
        submit_action = url("/repository/%s" % obj)
        redirect(submit_action)

    @expose(template="mirrormanager.templates.boringdeleteform")
    def delete(self, obj, **kwargs):
        print obj, kwargs
        obj = model.DBSession.query(Repository).filter_by(id = obj).one()
        confirmed = kwargs.get('confirmed', None)
        confirm_delete_form = ConfirmDeleteForm(submit_text="Yes, really delete it!")
        if confirmed:
            flash("%s has been deleted." % obj.name)
            model.DBSession.delete(obj)
            redirect(url("/adminview"))
        else:
            form = confirm_delete_form
            page_title = "Item Deletion"
            submit_action = url("/repository/delete/%s?confirmed=1" % (
                    obj.id))
            return dict(form=form, values=obj,
                    action=submit_action, page_title=page_title) 
