# -*- coding: utf-8 -*-
"""Site to site Controller"""

import transaction

from tg import expose, flash, require, url, request, redirect, validate
from tg.decorators import override_template
from pylons.i18n import ugettext as _, lazy_ugettext as l_
from tgext.admin.tgadminconfig import TGAdminConfig
from tgext.admin.controller import AdminController
from repoze.what import predicates
from sqlalchemy import and_

from mirrormanager.lib.base import BaseController
from mirrormanager.model import DBSession, metadata
from mirrormanager.controllers.error import ErrorController
from mirrormanager.controllers.secure import SecureController

from mirrormanager import model
from mirrormanager.model import *

from mirrormanager.controllers.forms import *
from mirrormanager.controllers.utils import *

site_to_site_form = SiteToSiteForm("create_site_to_site_form", 
                    submit_text='Add Downstream Site')


class SiteToSiteController(BaseController):
    allow_only = predicates.not_anonymous()

    @expose(template="mirrormanager.templates.boringsiteform")
    def new(self, **kwargs):
        siteid=kwargs['siteid']
        try:
            site = model.DBSession.query(Site).filter_by(id = siteid).one()
        except Exception, er:
            print "Error:", er
            raise redirect(url("/"))

        siteadmin_check(site, request.identity['repoze.who.userid'])
        submit_action = url("/site2site/create?siteid=%s" % siteid)
        return dict(form=site_to_site_form, 
            values=None, action=submit_action, 
            page_title="Add Downstream Site", site=site)
    
    @expose()
    @validate(form=site_to_site_form)
    #@error_handler(new)
    def create(self, siteid, sites):
        if siteid is None:
            flash("Error: form didn't provide siteid")
            raise redirect(url("/"))

        try:
            site = model.DBSession.query(Site).filter_by(id = siteid).one()
        except Exception, er:
            print "Error:", er
            flash("Error: Site %s does not exist" % siteid)
            raise redirect(url("/"))

        siteadmin_check(site, request.identity['repoze.who.userid'])
        for dssite in sites:
            if dssite == site.id:
                continue
            try:
                print site.id, dssite
                site2site = SiteToSite(upstream_site=site.id, downstream_site=dssite)
                model.DBSession.add(site2site)
            except Exception, er:
                print "Error l80:", er
                pass
        flash("SiteToSite created.")
        raise redirect("/site/%s" % siteid)
