# -*- coding: utf-8 -*-
"""Host Controller"""

from tg import expose, flash, require, url, request, redirect, validate, config

from mirrormanager.lib.base import BaseController
from mirrormanager.model import DBSession, metadata

from mirrormanager import model
from mirrormanager.model import *


admin_group = config.get('mirrormanager.admin_group', 'sysadmin')


class InvalidData(Exception):
    pass


def del_downstream_site(site, dsite):
    for s in model.DBSession.query(SiteToSite).filter_by(
        upstream_site=site.id, downstream_site=dsite).all():
        print s
        model.DBSession.delete(s)

def siteadmin_check(site, identity):
    if not site.is_siteadmin(identity):
        flash("Error:You are not an admin for Site %s" % site.name)
        raise redirect("/")

def downstream_siteadmin_check(site, identity):
    if not site.is_siteadmin(identity) \
        and not site.is_downstream_siteadmin(identity):
        print identity
        flash("Error:You are not an admin for Site %s or for a Site immediately downstream from Site %s" % (site.name, site.name))
        raise redirect("/")

def disabled_fields(site=None):
    disabled_fields = []
    if not predicates.in_group(admin_group):
        disabled_fields.append('admin_active')
    so = Site()
    if site is not None:
        if not so.is_siteadmin(request.identity['repoze.who.userid']):
            for a in ['password', 'user_active', 'private']:
                disabled_fields.append(a)
    return disabled_fields
