# -*- coding: utf-8 -*-
"""Sample model module."""

from sqlalchemy import *
from sqlalchemy.orm import mapper, relation
from sqlalchemy import Table, ForeignKey, Column
from sqlalchemy.types import Integer, Unicode
#from sqlalchemy.orm import relation, backref

from mirrormanager.model import DeclarativeBase, metadata, DBSession


class Directory(DeclarativeBase):
    __tablename__ = 'directory'
    
    id = Column(Integer, primary_key=True)
    # Full path
    # e.g. pub/fedora/linux/core/6/i386/os
    # e.g. pub/fedora/linux/extras
    # e.g. pub/epel
    # e.g. pub/fedora/linux
    name = Column(Text)
    files = Column(PickleType, default={})
    readable = Column(Boolean, default=True)
    ctime = Column(BigInteger, default=0)
    #categories = RelatedJoin('Category')
    #repository = SingleJoin('Repository') # zero or one repository, set if this dir contains a yum repo
    #host_category_dirs = MultipleJoin('HostCategoryDir')
    #fileDetails = MultipleJoin('FileDetail', orderBy=['filename', '-timestamp'])
    #exclusive_hosts = MultipleJoin('DirectoryExclusiveHost')

    def destroySelf(self):
        for c in self.categories:
            self.removeCategory(c)
        if self.repository is not None:
            self.repository.destroySelf()
        # don't destroy a whole category if only deleting a directory
        for hcd in self.host_category_dirs:
            hcd.destroySelf()
        for fd in self.fileDetails:
            fd.destroySelf()
        for eh in self.exclusive_hosts:
            eh.destroySelf()
        SQLObject.destroySelf(self)
