# -*- coding: utf-8 -*-
"""Sample model module."""

from sqlalchemy import *
from sqlalchemy.orm import mapper, relation
from sqlalchemy import Table, ForeignKey, Column
from sqlalchemy.types import Integer, Unicode
#from sqlalchemy.orm import relation, backref

from mirrormanager.model import DeclarativeBase, metadata, DBSession


class HostCategory(DeclarativeBase):
    __tablename__ = 'host_category'
    
    #{ Columns
    
    id = Column(Integer, primary_key=True)
    host = Column('host_id', Integer, ForeignKey("host.id"))
    category = Column('category_id', Integer, ForeignKey("category.id"))
    hcindex = UniqueConstraint('host', 'category', name='hcindex')
    admin_active = Column(Boolean, default=True)
    user_active = Column(Boolean, default=True)
    upstream = Column(Text, default=None)
    always_up2date = Column(Boolean, default=False)
    #always_up2date = BoolCol(default=False)
    #dirs = MultipleJoin('HostCategoryDir', orderBy='path')
    #urls = MultipleJoin('HostCategoryUrl')
    
    #}
    
    def destroySelf(self):
        """Cascade the delete operation"""
        for b in self.urls:
            b.destroySelf()
        for d in self.dirs:
            d.destroySelf()
        SQLObject.destroySelf(self)
