# -*- coding: utf-8 -*-
"""Sample model module."""

from sqlalchemy import *
from sqlalchemy.orm import mapper, relation
from sqlalchemy import Table, ForeignKey, Column
from sqlalchemy.types import Integer, Unicode
from sqlalchemy.orm import relationship
from mirrormanager.model.auth import group_permission_table

from mirrormanager.model import DeclarativeBase, metadata, DBSession


class Permission(DeclarativeBase):
    __tablename__ = 'permission'

    id = Column(Integer, primary_key=True)
    host = Column('host_id', Integer, ForeignKey('host.id'))
    permission_name = Column(Text)
    description = Column(Text)

    #groups = relation('Group', secondary=, backref='groups')
    groups = relationship("Group",
                    secondary=group_permission_table, backref='groups')
